package com.ruoyi.board.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.github.yulichang.base.MPJBaseServiceImpl;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.stereotype.Service;
import com.ruoyi.board.domain.AlertPlan;
import com.ruoyi.board.mapper.AlertPlanMapper;
import com.ruoyi.board.service.IAlertPlanService;

import java.util.List;

@Service
public class AlertPlanServiceImpl extends MPJBaseServiceImpl<AlertPlanMapper, AlertPlan> implements IAlertPlanService {

    @Override
    public List<AlertPlan> selectList(AlertPlan alertPlan) {
        LambdaQueryWrapper<AlertPlan> alertPlanLambdaQueryWrapper = new LambdaQueryWrapper<>();
        alertPlanLambdaQueryWrapper.eq(ObjectUtils.isNotEmpty(alertPlan.getType()), AlertPlan::getType, alertPlan.getType());
        alertPlanLambdaQueryWrapper.eq(ObjectUtils.isNotEmpty(alertPlan.getLevel()), AlertPlan::getLevel, alertPlan.getLevel());
        return list(alertPlanLambdaQueryWrapper);
    }

    @Override
    public AlertPlan getOneByTypeAndValue(Integer planType, Double value) {
        if (planType < 0) {
            return null;
        }
        LambdaQueryWrapper<AlertPlan> alertPlanLambdaQueryWrapper = new LambdaQueryWrapper<>();
        alertPlanLambdaQueryWrapper
                .eq(AlertPlan::getType, planType)
                .le(AlertPlan::getMinValue, value)
                .ge(AlertPlan::getMaxValue, value);
        return getOne(alertPlanLambdaQueryWrapper);
    }
}
